#   This file is part of Gnupylot.
#
#    Gnupylot is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    Gnupylot is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Gnupylot; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
'''
Created on 10/gen/2010

@author: Lorenzo Rovigatti
'''

import sys

# thanks to http://stackoverflow.com/questions/2617704/checking-for-module-availability-programmatically-in-python
def checkModules():
    import imp

    modules = ("numpy", "PyQt4")
    for mod in modules:
        try:
            imp.find_module(mod)
        except ImportError:
            print "Required module '%s' not found, exiting." % mod
            sys.exit(-1)

# this is a revisited function inspired by emesene.
def parseArgs():
    '''
    Parse command line arguments using getopt and returns a tuple suitable to be passed
    to the MainWindow.
    '''
    gnuplot_bin = None
    debug = False

    try:
        import getopt
    except ImportError:
        # getopt is disabled in py2exe
        return ('', False, False, False)

    shortArgs = 'd'
    longArgs = ['debug', 'gnuplot_bin=']

    try:
        args = getopt.getopt(sys.argv[1:], shortArgs, longArgs)
    except getopt.GetoptError, e:
        # something went wrong, display usage
        print e
        print 'Usage: ', sys.argv[0], '[-d|--debug] | [--gnuplot_bin=PATH_TO_GNUPLOT_BIN]'
        sys.exit(-1)

    for key, value in args[0]:
        if key == '-d' or key == '--debug':
            debug = True
        if key == '--gnuplot_bin':
            gnuplot_bin = value

    return {"gnuplot_bin" : gnuplot_bin, "debug" : debug, "files" : args[1]}

def main():
    """Main function. Starts the application and loops over messages."""
    checkModules()
    args = parseArgs()

    from PyQt4 import QtGui
    app = QtGui.QApplication(sys.argv)
    app.setApplicationName("Gnupylot")

    from Controller import Controller
    Controller(parent=app, **args)

    res = app.exec_()
    sys.exit(res)

if __name__ == '__main__':
    main()

