#   This file is part of Gnupylot.
#
#    Gnupylot is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    Gnupylot is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Gnupylot; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
'''
Created on 20/gen/2010

@author: Lorenzo Rovigatti
'''

# this stuff comes from Emesene's paths.py 
import os
import sys
from PyQt4.QtCore import QDir

DIR_SEP = os.sep

if hasattr(sys, "frozen"):
    APP_PATH = os.path.dirname(sys.executable)
else:
    APP_PATH = os.path.abspath(os.path.dirname(__file__)) + "/../.."

def getConfigDir():
    """
    Returns the config directory ($HOME/.gnupylot). Creates it if it doesn't exists.
    """
    curr_dir = QDir.home()
    config_exists = curr_dir.cd(".gnupylot")
    if config_exists == False:
        curr_dir.path()
        created = curr_dir.mkdir(".gnupylot")
        if created == False:
            import common
            common.debug("Couldn't create .gnupylot curr_directory", "current user's home directory: %s" % curr_dir.path())

    curr_dir.cd(".gnupylot")

    return curr_dir.path() + os.sep
